// Creating a shortcut

// This file is public domain.

#undef UNICODE
#define UNICODE
#undef _UNICODE
#define _UNICODE

#include "shobjidl.h"
#include "objbase.h"
#include "objidl.h"
#include "shlguid.h"

using namespace std;

extern "C" int make_shortcut( wchar_t * target, wchar_t * link_loc ) {

  HRESULT hr;
  IShellLink * psl;
  IPersistFile * ppf;

  hr = CoInitializeEx( NULL, COINIT_APARTMENTTHREADED|COINIT_DISABLE_OLE1DDE );
  if( !SUCCEEDED( hr )) return 0;

  hr = CoCreateInstance( CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
      IID_IShellLink, ( LPVOID* )&psl );
  if( !SUCCEEDED( hr )) return 0;
  psl->SetPath( target );
  psl->SetDescription( NULL );
  hr = psl->QueryInterface( IID_IPersistFile, ( LPVOID* )&ppf );
  if( SUCCEEDED( hr )) {
    hr = ppf->Save( link_loc, TRUE );
    ppf->Release();
  }
  psl->Release();
  CoUninitialize();
  return SUCCEEDED( hr ) ? 1 : 0;
}
